﻿--                    .----.            .------------------`    -------.         -------.             
--                   .NMMMMm.           dMMMMMMMMMMMMMMMMMM:   `mMMMMMMM-       +MMMMMMMy             
--                  `dMMMMMMd           dMMMMMMMMMMMMMMMMMM:   `mMMMMMMMy      `mMMMMMMMy             
--                  yMMMMMMMMs          dMMMM/                 `mMMMMNMMM-     oMMMNMMMMy             
--                 +MMMMoyMMMM+         dMMMM/                 `mMMMMoMMMh    `mMMNoMMMMy             
--                -NMMMh `mMMMN:        dMMMMs------------`    `mMMMM.mMMM:   oMMMy:MMMMy             
--               .mMMMN.  -NMMMN.       dMMMMMMMMMMMMMMMMM:    `mMMMN`+MMMd  .NMMM-:MMMMy             
--               hMMMM/    +MMMMd`      dMMMMMNNNNNNNNNNNN:    `mMMMN``mMMM/ sMMMh :MMMMy             
--              sMMMMNhyyyyhMMMMMy      dMMMM/                 `mMMMN` oMMMm-NMMM- -MMMMy             
--             /MMMMMMMMMMMMMMMMMM+     dMMMM/                 `mMMMN  `NMMMmMMMh  -MMMMy             
--            -NMMMNsoooooooosNMMMM:    dMMMM/                 `mMMMN   oMMMMMMM:  -MMMMy             
--           `mMMMM+          +MMMMN.   dMMMMmhhhhhhhhhhhhhs   `mMMMN   .NMMMMMd   -MMMMy             
--           hMMMMh            yMMMMd`  dMMMMMMMMMMMMMMMMMMh   `mMMMm    sMMMMM:   .MMMMy             
--          .ooooo`            `ooooo-  /oooooooooooooooooo/    +ooo+    `oooo+    `oooo:      
--MPREADY: American Eagles Modteam (TwistedGA & looseterror)
--www.americaneaglesmodding.com
--looseterror & TwistedGA (American Eagles Modteam)
--graintrailer
-- Specialization for graintrailer
--

graintrailer = {};

function graintrailer.prerequisitesPresent(specializations)
    return true;
end;

function graintrailer:load(xmlFile)
	self.trailertarp = SpecializationUtil.callSpecializationsFunction("trailertarp");

	self.Plane1 = Utils.indexToObject(self.components, getXMLString(xmlFile,"vehicle.Plane1#index"));
	
	self.isOpen = true; 
	setVisibility(self.Plane1, self.isOpen);
end;

function graintrailer:delete()
end;

function graintrailer:readStream(streamId, connection)
    self.isOpen = streamReadBool(streamId);
end;

function graintrailer:writeStream(streamId, connection)
    streamWriteBool(streamId, self.isOpen);
end;

function graintrailer:readUpdateStream(streamId, timestamp, connection)
	if connection:getIsServer() then
		if streamReadBool(streamId) then
		end;
	end;
end;

function graintrailer:writeUpdateStream(streamId, connection, dirtyMask)
	if not connection:getIsServer() then
		if streamWriteBool(streamId, bitAND(dirtyMask, self.vehicleDirtyFlag) ~= 0) then
        end;
    end;
end;

function graintrailer:mouseEvent(posX, posY, isDown, isUp, button)
end;

function graintrailer:keyEvent(unicode, sym, modifier, isDown)
end;

function graintrailer:update(dt)	
	if self.isClient then
		if self:getIsActive() and self:getIsActiveForInput() then
			if InputBinding.hasEvent(InputBinding.Tarp) then
				self.isOpen = not self.isOpen
				self:trailertarp(self.isOpen);
			end;		
		end;
	end;
end;

function graintrailer:draw()
	if self.isOpen then
		g_currentMission:addExtraPrintText(g_i18n:getText("Tarp_2"),InputBinding.Tarp);
	else
		g_currentMission:addExtraPrintText(g_i18n:getText("Tarp_1"),InputBinding.Tarp);
	end;
end;

function graintrailer:trailertarp(currenttarp, noEventSend)
	TrailerTarpEvent.sendEvent(self,currenttarp,noEventSend);
	if currenttarp then
		self.isOpen = true;
	else
		self.isOpen = false;
	end;
	setVisibility(self.Plane1, self.isOpen);
end;

function graintrailer:onAttach(attacherVehicle)
end;

function graintrailer:onDetach()
end;

function graintrailer:onLeave()
end;

function graintrailer:onDeactivate()
end;

function graintrailer:onDeactivateSounds()
end;

TrailerTarpEvent = {};
TrailerTarpEvent_mt = Class(TrailerTarpEvent, Event);

InitEventClass(TrailerTarpEvent, "TrailerTarpEvent");

function TrailerTarpEvent:emptyNew()
    local self = Event:new(TrailerTarpEvent_mt);
    self.className="TrailerTarpEvent";
    return self;
end;

function TrailerTarpEvent:new(vehicle, currenttarp)
    local self = TrailerTarpEvent:emptyNew()
    self.vehicle = vehicle;
	self.currenttarp = currenttarp;
    return self;
end;

function TrailerTarpEvent:readStream(streamId, connection)
    local id = streamReadInt32(streamId);
	self.currenttarp = streamReadBool(streamId);
    self.vehicle = networkGetObject(id);
    self:run(connection);
end;

function TrailerTarpEvent:writeStream(streamId, connection)
    streamWriteInt32(streamId, networkGetObjectId(self.vehicle));
	streamWriteBool(streamId, self.currenttarp);
end;

function TrailerTarpEvent:run(connection)
	self.vehicle:trailertarp(self.currenttarp, true);
    if not connection:getIsServer() then
        g_server:broadcastEvent(TrailerTarpEvent:new(self.vehicle, self.currenttarp), nil, connection, self.vehicle);
    end;
end;

function TrailerTarpEvent.sendEvent(vehicle, currenttarp, noEventSend)
	if noEventSend == nil or noEventSend == false then
		if g_server ~= nil then
			g_server:broadcastEvent(TrailerTarpEvent:new(vehicle, currenttarp), nil, nil, vehicle);
		else
			g_client:getServerConnection():sendEvent(TrailerTarpEvent:new(vehicle, currenttarp));
		end;
	end;
end;